#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <fmt.h>
#include <str.h>

#define MAX_FMT		10
#define MAX_ORIG	10
#define MAX_NEW		2

/* Helper functions */
char *fmt_generic (char *text, int num, char orig[MAX_FMT][MAX_ORIG], 
	char new[MAX_FMT][MAX_NEW])
{
	char *ret=(char *)malloc(strlen(text)+1), *tmp;
	int i;

	strcpy (ret, text);

	for (i=0;i<num;i++)
	{
		tmp=ret;
		ret=strrep(ret, orig[i], new[i]);
		free(tmp);
	}

	return ret;
}

char *fmt_html (char *text)
{
	char tags[MAX_FMT][MAX_ORIG] = {"&quot;", "&apos;", "&lt;", "&gt;", "&amp;"};
	char repl[MAX_FMT][MAX_NEW] = {"\"", "'", "<", ">", "&"};
	
	return fmt_generic(text, 5, tags, repl);
}

char *fmt_utf8 (char *text)
{
	char tags[MAX_FMT][MAX_ORIG] = {"ü", "ö", "ä", ""};
	char repl[MAX_FMT][MAX_NEW] = {"", "", "", ""};

	return fmt_generic(text, 4, tags, repl);
}

char *fmt_rmesc (char *text)
{
	char *ret=(char *)malloc(strlen(text)+1), *tmp;

	strcpy(ret, text);
	tmp=ret;
	ret=strkill(ret, "\n");
	free(tmp);

	return ret;
}

char *fmt_date (time_t val)
{
	char *tstr, *ret;
    struct tm tm;
	time_t curtime;

	if (val==0)
	{
		if (time(&curtime)==-1)
		{
			perror("fmt_date");
			return NULL;
		}
	}
	else
		curtime=val;

	tm=*localtime(&curtime);
	tstr=ctime(&curtime);
	tstr[strlen(tstr)-1]='\0';
	ret=(char *)malloc(strlen(tstr)+strlen(tm.tm_zone)+2);

#ifdef __dietlibc__
	strcpy(ret, tstr);
#else
	sprintf(ret, "%s %s", tstr, tm.tm_zone);
#endif
	
	return ret;
}
