#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <netinet/in.h>

#include <sock.h>

void sock_open (sock *sck, char *ip, int port)
{
	if (port==-1)
	{
		sck->type=SOCK_UN;
		sck->fd=socket(AF_UNIX, SOCK_STREAM, 0);
		sck->un_adr.sun_family=AF_UNIX;
		strcpy(sck->un_adr.sun_path, ip);
		sck->len=sizeof(sck->un_adr);
		sck->adr=(struct sockaddr *)&sck->un_adr;
	}
	else
	{
		sck->type=SOCK_IN;
		sck->fd=socket(AF_INET, SOCK_STREAM, 0);
		sck->in_adr.sin_family=AF_INET;
		sck->in_adr.sin_addr.s_addr=inet_addr(ip);
		sck->in_adr.sin_port=htons(port);
		sck->len=sizeof(sck->in_adr);
		sck->adr=(struct sockaddr *)&sck->in_adr;
	}
}

int sock_con (sock *sck)
{
	int result;

	result=connect(sck->fd, sck->adr, sck->len);

	if (result==-1)
	{
		perror("sock_con");
		return 1;
	}

	return 0;
}

int sock_write (sock *sck, char *data)
{
	return write(sck->fd, data, strlen(data));
}

int sock_writech (sock *sck, char ch)
{
	char *data=(char *)malloc(2);
	int ret;

	data[0]=ch;
	data[1]='\0';
	ret=sock_write(sck, data);
	free(data);

	return ret;
}

char *sock_read (sock *sck, int count)
{
	char *data=(char *)malloc(count+1);
	int c;

	c=read(sck->fd, data, count);
	if (c>0)
		data[c]='\0';
	if (c==0)
		return NULL;
	
	return data;
}

char sock_readch (sock *sck)
{
	char *tmp, ch;
	
	tmp=sock_read(sck, 1);
	if (!tmp)
		ch=' ';
	else
	{
		ch=tmp[0];
		free(tmp);
	}

	return ch;
}

int sock_close (sock *sck, bool freeme)
{
	int ret=close(sck->fd);

	if (freeme)
		free(sck);
		
	return ret;
}

int sock_bind (sock *sck)
{
	if (bind(sck->fd, sck->adr, sck->len)==-1)
	{
		perror("sock_bind");
		return 1;
	}

	return 0;
}

int sock_listen (sock *sck, int cons)
{
	return listen(sck->fd, cons);
}

int sock_accept (sock *lsock, sock *sck)
{
	if (lsock->type==SOCK_UN)
		sck->adr=(struct sockaddr *)&sck->un_adr;
	else
		sck->adr=(struct sockaddr *)&sck->in_adr;
	
	sck->len=sizeof(sck->adr);
	sck->fd=accept(lsock->fd, sck->adr, (socklen_t *)&sck->len);

	if (sck->fd==-1)
	{
		perror("sock_accept");
		return 1;
	}

	return 0;
}
