#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <stdbool.h>

#include <fmt.h>
#include <str.h>
#include <http.h>

/* Simple HTTP server */

#define _404_		"<html><head><title>404 Not Found</title></head>\n<body>The requested URL was not found on this server.\n</body></html>"
#define BANNER		"sploitme httpd 0.0.1"
#define WWW_ROOT	"../../etc/cache/"

int main (int argc, char **argv)
{
	int ocle=true, port=8082;
	char *req, *file, *proto, *ua, *tmp, ch;
	FILE *reqfile;
	sock srv_sock, cl_sock;
	struct stat buf;
	
	/* Open a socket, accept connections */
	while (ocle)
	{
		sock_open(&srv_sock, "127.0.0.1", port);
		if (!sock_bind(&srv_sock))
			ocle=false;
		else
			port++;
	}
	reqfile=fopen("port", "w");
	tmp=(char *)malloc(10);
	snprintf(tmp, 10, "%i", port);
	fputs(tmp, reqfile);
	fclose(reqfile);
	
	sock_listen(&srv_sock, 5);
	sock_accept(&srv_sock, &cl_sock);
	
	/* Process HTTP request */
	req=http_req(&cl_sock);
	file=http_get_file(req);
	proto=http_get_proto(req);
	ua=http_header(req, "User-Agent");
	
	tmp=strdog(WWW_ROOT, file);
	reqfile=fopen(tmp, "r");
	free(tmp);
	
	if (reqfile)
	{
		tmp=strdog(proto, " 200 OK\n");
		sock_write(&cl_sock, tmp);
		free(tmp);
		
		tmp=(char *)malloc(100);
		snprintf(tmp, 99, "Date: %s\n", fmt_date(0));
		sock_write(&cl_sock, tmp);
		free(tmp);

		tmp=(char *)malloc(100);
		snprintf(tmp, 99, "Server: %s\n", BANNER);
		sock_write(&cl_sock, tmp);
		free(tmp);

		sock_write(&cl_sock, "Connection: close\n");

		tmp=strdog(WWW_ROOT, file);
		stat(tmp, &buf);
		free(tmp);
		tmp=(char *)malloc(100);
		snprintf(tmp, 99, "Content-Length: %i\n", (int)buf.st_size);
		sock_write(&cl_sock, tmp);
		free(tmp);

		tmp=(char *)malloc(100);
		snprintf(tmp, 99, "Last-Modified: %s\n", fmt_date(buf.st_mtime));
		sock_write(&cl_sock, tmp);
		free(tmp);

		sock_write(&cl_sock, "Content-Type: text/plain");
	}
	else
	{
		tmp=strdog(proto, " 404 Not Found\n");
		sock_write(&cl_sock, tmp);
		free(tmp);
	}
	sock_write(&cl_sock, "\r\n\r\n");
	if (reqfile)
	{
		char *tst1, *tst2;
		
		tst1=(char *)malloc(2);
		tst1[0]='\0';
		ch=fgetc(reqfile);
		while (ch!=EOF)
		{
			tst2=tst1;
			tst1=(char *)malloc(strlen(tst2)+2);
			sprintf(tst1, "%s%c", tst2, ch);
			free(tst2);
			sock_writech(&cl_sock, ch);
			ch=fgetc(reqfile);
		}
		fclose(reqfile);
	}
	else
	{
		sock_write(&cl_sock, _404_);
	}
	
	/* Free memory */
	free(req);
	free(file);
	free(proto);
	free(ua);
	
	/* Close sockets */		
	sock_close(&cl_sock, false);
	return sock_close(&srv_sock, false);	
}
