#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <string.h>

#include <config.h>
#include <rss-handler.h>
#include <gui.h>
#include <fmt.h>
#include <str.h>

#define MENU		0
#define FEED_MENU	1
#define FEED_READ	2

#define BORDER		3

int feedc, itemc, sel;
feed *feeds;
newsitem *items, item;

void initialize_gui ()
{
	init_gui();
	inp_nblk();
	inp_kpad();
}

void draw_gui (int stat)
{
	char *t1;
	int chc, i;
	
	erase();
	mov_head();
	print_top(TITLE);
	mov_foot();
	print_top("");
#ifdef SHITSKI
	scrtxt(STEXT, LINES-1, 1);
#else
	if (stat==MENU)
	{
		set_color(1);	
		move(LINES-1, 1);
		t1=strcut(feeds[sel].desc, 0, COLS-2);
		printw("%s", t1);
		free(t1);
		set_color(0);
	}
#endif

	switch (stat)
	{
		case MENU:
			for (i=0;i<feedc;i++)
			{
				move(3+i, 5);
				if (sel==i) set_color(MENU_SEL);
				printw("%s", feeds[i].title);
				set_color(0);
			}
			break;
		case FEED_MENU:
			if (itemc==0)
			{
				move(3, 5);
				printw("No news items available.");
			}
			
			for (i=0;i<itemc;i++)
			{
				move(3+i, 5);
				if (items[i].read==false)
					bold_font();
				if (sel==i) set_color(MENU_SEL);
				if (strlen(items[i].title)>COLS-10)
				{
					t1=strcut(items[i].title, 0, COLS-10);
					printw("%s", t1);
					free(t1);
				}
				else
					printw("%s", items[i].title);
				set_color(0);
				norm_font();
			}
			break;
		case FEED_READ:
			move (3, 5);
			bold_font();
			printw("%s", item.title);
			norm_font();
			chc=(float)strlen(item.desc)/(COLS-(BORDER*2))+1;
			for (i=0;i<chc;i++)
			{
				move(5+i, BORDER);
				t1=strcut(item.desc, i*(COLS-(BORDER*2)), COLS-(BORDER*2));
				printw("%s", t1);
				free(t1);
			}
			break;
		default:
			break;
	}

#ifdef SHITSKI
	usleep(GUI_MT_IV);
#endif
	refresh();
}

int main (int argc, char **argv)
{
	int key, i=0, stat=MENU, sel_max;
	char *cdir, *tmp, *browser;
	DIR *cache_dir;
	FILE *conf;
	struct dirent *dire;

	cdir=strdog(CONFDIR, "/cache/");
	cache_dir=opendir(cdir);
	if (!cache_dir)
	{
		perror(cdir);
		return 1;
	}
	feedc=0;
	while ((dire=readdir(cache_dir))&&(dire))
		if ((strncmp(dire->d_name, ".", 1)))
			feedc++;
	seekdir(cache_dir, 0);
	feeds=(feed *)malloc(feedc*sizeof(feed));
	while ((dire=readdir(cache_dir))&&(dire))
		if ((strcmp(dire->d_name, ".")&&(strcmp(dire->d_name, ".."))))
		{
			tmp=strdog(cdir, dire->d_name);
			if (!rss_init_cache(&feeds[i], tmp))
				i++;
			else
				feedc--;
			free(tmp);
		}
	closedir(cache_dir);

	/* Handle browser configuration */
	conf=fopen(strdog(CONFDIR, "/browser"), "r");
	if (conf)
	{
		browser=(char *)malloc(256);
		fgets(browser, 255, conf);
		fclose(conf);
		if (!browser)
			strcpy(browser, "lynx %s");
	}
	else
		browser="lynx %s";
	
	initialize_gui();	
	sel=0;
	sel_max=feedc-1;

	do 
	{
		draw_gui(stat);
		key = getch();

		switch (key)
		{
			case KEY_ENTER:
				switch (stat)
				{
					case MENU:
						stat=FEED_MENU;
						items=rss_parse(&feeds[sel], true);
						itemc=feeds[sel].count;
						sel=0;
						sel_max=itemc-1;
						break;
					case FEED_MENU:
						if (itemc)
						{
							stat=FEED_READ;
							item=items[sel];
						}
						break;
					case FEED_READ:
						break;
					default:
						break;
				}
				break;
			case KEY_DOWN:
				sel++;
				break;
			case KEY_UP:
				sel--;
				break;
			case KEY_LEFT:
				if (stat==FEED_READ)
				{
					sel=sel-1;
					if (sel<0)
						sel=0;
					item=items[sel];
				}
				break;
			case KEY_RIGHT:
				if (stat==FEED_READ)
				{
					sel=sel+1;
					if (sel>sel_max)
					{
						sel=0;
						stat=MENU;
						sel_max=feedc-1;
					}
					item=items[sel];
				}
				break;
			case 'l':
				switch (stat)
				{
					case MENU:
						if (strlen(feeds[sel].url)>1)
						{
							finalize_gui();
							tmp=(char *)malloc(256);
							snprintf(tmp, 255, browser, feeds[sel].url);
							system(tmp);
							free(tmp);
							init_gui();
							draw_gui(stat);
						}
						break;
					case FEED_MENU:
						break;
					case FEED_READ:
						if (strlen(item.url)>1)
						{
							finalize_gui();
							tmp=(char *)malloc(256);
							snprintf(tmp, 255, browser, item.url);
							system(tmp);
							free(tmp);
							init_gui();
							draw_gui(stat);
						}
						break;
					default:
						break;
				}
				break;
			case 'q':
				switch (stat)
				{
					case MENU:
						key=KEY_ESC;
						break;
					case FEED_MENU:
						stat--;
						sel=0;
						sel_max=feedc-1;
						free(items);
						break;
					case FEED_READ:
						stat--;
						sel=0;
						sel_max=itemc-1;
						break;
					default:
						break;
				}
				break;
		}
		
		if (sel<0)
			sel=sel_max;
		if (sel>sel_max)
			sel=0;
		
	} while (key!=KEY_ESC); 
	
	finalize_gui();
	
	free(cdir);
	free(feeds);
	/*free(items);*/
	return 0;
}
